////////////////////////////////////////////////////////////////////////
// cube3.c
// Affichage d'un cube 3d en fil de fer
// VERSION :
//  - Avec double buggering
//  - utilisation de PutPixelFastMode1
////////////////////////////////////////////////////////////////////////
#include "conio2.h"
#include <stdio.h>
#include <math.h>

#define KM_WAIT_CHAR_s \
	__asm \
	call #0xBB06 \
	__endasm

#define  SCR_SET_MODE1_s \
	__asm	ld a,#1 \
	call #0xBC0E \
	__endasm;


/* Tableaux precalcules de sinus et cosinus */
char  *TSIN;
char  *TCOS;
#define FLOAT_MULT 127
#define DEG2RAD(a) (((a)*PI)/180.0)

// IL FAUT UTILISER "--oldralloc" POUR COMPILER !
// code retout :
// 0 Ok
// -1 Erreur
int SaveFileBin(char* filename, char* readbuffer, int lenght)
{
__asm

	; Initialisation de l amsdos (ROM 7) avant le changement d un fichier
	ld   	hl,(#0xBE7D)	; adresse de la zone rserve AMSDOS
	ld   	a,(hl)			; drive
	push 	hl
	push 	af
	ld      de,#0x40		;DE-HL contient la plage dans laquelle la rom doit tre recherche
	ld      hl,#0xABFF
	ld      c,#7			;contient l adresse de slection de rom  tester
	call    #0xBCCE			;initialisation d'une rom de second plan
	pop		af
	pop		hl
	ld		(hl),a			; on remet le drive courant
	
	; rcupere le parametre char* filename
	LD L, 4(IX)
	LD H, 5(IX)
	;LD B, 8(IX)
	
	; calcule la longeur du nom de fichier
	call getfilenamesize
	
	; B = longueur du nom de fichier en caractres
	; HL = l adresse de dbut du nom de fichier
	
	;; DE = l adresse d'un tampon 2k
	;; En mode disque: cette mmoire tampon n'est pas utilis lorsque Fonction firmware 
	;; CAS EN DIRECT est utilis, il est donc prudent de le mettre nulle (0)
	;; Vous le souhaitez.
	ld de,#0

	;; fonction du firmware pour ouvrir un fichier en ecriture
	call #0xBC8C

	;; cas_in_open retour:
	;; si le fichier a t ouvert avec succs:
	;; - carry est vrais
	;; - HL contient l adresse de l en-tte du fichier s AMSDOS
	;; - DE contient l adresse de chargement du fichier ( partir de l en-tte)
	;; - BC contient la longueur du fichier ( partir de l en-tete du fichier)
	;; - A contient le type de fichier (2 pour les fichiers binaires)
	; si une erreur on sort le la fonction
	JR NC,ERRDRIV
	JR Z,ERRDRIV
	
	;; fonction du firmware pour charger le fichier en entier
	;; cela fonctionne avec les fichiers qui ont un en-tte AMSDOS (les
	;; fichiers ASCII n'ont pas un en-tte)
	
	; rcupere le parametres char* readbuffer
	LD L, 6(IX)
	LD H, 7(IX)

	; rcupere le parametres int lenght
	LD E, 8(IX)
	LD D, 9(IX)

	LD A, #2  ; Type de fichier (binaire)
	
	; BC l adresse du point d entree;
	;LD B,H
	;LD C,L
	LD BC,#0
	
	;; Ecriture du fichier
	call #0xBC98

	;; fonction du firmware pour fermer un fichier ouvert en ecriture
	call #0xBC8F
	
	jp asmFin

ERRDRIV:
	;LD (FLGERR),A  ;Sort ici si erreur drive
	CALL #0xBC92
	; il y a une erreur, on retourne cette erreur....
	; enfin pour le moment juste la valeur -1
	ld	hl,#0xFFFF
	pop	ix
	ret
	
	
getfilenamesize:
	push de
	push hl
	ld e,#0
getfilenamesizeloop:
	ld a, (hl)
	or a
	jp z, getfilenamesizeend
	inc hl
	inc e
	jp getfilenamesizeloop
getfilenamesizeend:
	pop hl
	ld b, e
	pop de
	ret	
	
asmFin: 

	
__endasm;
}

void main()
{
  int i;
  
  TSIN = (char *)((unsigned int)0x8000);
  TCOS = (char *)((unsigned int)0x8000+360);

  gotoxy(1,1); printf("Calcule des sin et cos");
  for(i=0;i<360;i++)
  {
	TSIN[i]=sinf(DEG2RAD(i))*FLOAT_MULT;
	TCOS[i]=cosf(DEG2RAD(i))*FLOAT_MULT;

	gotoxy(1,2);printf("%d", i);
  }

  gotoxy(1,1); printf("Calcule terminer           ");
  gotoxy(1,2); printf("une touche pour sauver         ");
  KM_WAIT_CHAR_s;
  SaveFileBin("sincosb.dat", 0x8000, 360*2);
  
  gotoxy(1,1); printf("Sauvegarde fini                 ");
  gotoxy(1,2); printf("une touche pour finir");
  KM_WAIT_CHAR_s;
}

